SHELL	= /bin/sh

#ifdef _AIX
CC	= cc -qlanglvl=ansi
#endif

CFLAGS	= 

OBJS    = driver.o tdcore.o err.o source.o SourceNode.o treecon.o \
	visitprocs.o AttrDefs.o GlobDef.o db.o deftbl.o idn.o csm.o envmod.o \
	LigaDid.o List.o Names.o liga_To_func.o Syntax.o GramCon.o ptg_gen.o \
	OutStr.o SymInh.o IntfAttrib.o SymComp.o obstack.o treestack.o \
	glahead.o p_mkstr.o str.o pascalCom.o auxScanEOL.o CchStr.o int.o \
	Ccomment.o pascalStr.o attrmain.o dfltclp.o

Lido.exe:	$(OBJS) ../../idl/IDL.a
	$(CC) -o Lido.exe $(CFLAGS) $(OBJS) ../../idl/IDL.a

clean:
	rm -f a.out *.o *.a core ERRS Lido.exe

driver.o:       driver.c HEAD.h INIT.h FINL.h treecon.h deftbl.h \
ptg_gen.h LIGA.h LIGAMacros.h liga_func.h liga_To_func.h ligaconsts.h \
err.h idn.h csm.h envmod.h List.h deftbl.h db.h Syntax.h AttrDefs.h \
GlobDef.h IntfAttrib.h LigaDid.h SymComp.h SymInh.h Names.h GramCon.h \
treestack.h global.h deftbl.h 
tdcore.o:       tdcore.c ptabs.h tdframe.h parser.h semprods.h err.h 
err.o:  err.c err.h source.h 
source.o:       source.c source.h 
SourceNode.o:   SourceNode.c err.h treecon.h treestack.h 
treecon.o:      treecon.c HEAD.h node.h visitprocs.h gsdescr.h \
obstack.h treecon.h deftbl.h ptg_gen.h LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h treestack.h global.h deftbl.h err.h 
visitprocs.o:   visitprocs.c HEAD.h err.h node.h visitprocs.h glattr.h \
attrpredef.h treecon.h deftbl.h ptg_gen.h LIGA.h LIGAMacros.h \
liga_func.h liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h \
List.h deftbl.h db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h \
LigaDid.h SymComp.h SymInh.h Names.h GramCon.h treestack.h global.h \
deftbl.h err.h 
AttrDefs.o:     AttrDefs.c Lido.head LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h global.h deftbl.h 
GlobDef.o:      GlobDef.c Lido.head LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h global.h deftbl.h 
db.o:   db.c HEAD.h deftbl.h treecon.h deftbl.h ptg_gen.h LIGA.h \
LIGAMacros.h liga_func.h liga_To_func.h ligaconsts.h err.h idn.h csm.h \
envmod.h List.h deftbl.h db.h Syntax.h AttrDefs.h GlobDef.h \
IntfAttrib.h LigaDid.h SymComp.h SymInh.h Names.h GramCon.h treestack.h \
global.h deftbl.h 
deftbl.o:       deftbl.c err.h deftbl.h 
idn.o:  idn.c err.h idn.h csm.h idntbl.h 
csm.o:  csm.c csm.h err.h csmtbl.h 
envmod.o:       envmod.c err.h envmod.h deftbl.h 
LigaDid.o:      LigaDid.c ligaconsts.h LigaDid.h 
List.o: List.c List.h 
Names.o:        Names.c err.h idn.h csm.h Names.h 
liga_To_func.o: liga_To_func.c LIGA.h LIGAMacros.h liga_To_func.h \
global.h 
Syntax.o:       Syntax.c Lido.head LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h global.h deftbl.h 
GramCon.o:      GramCon.c Lido.head ptg_gen.h lookup_idl.h LIGA.h \
LIGAMacros.h liga_func.h liga_To_func.h ligaconsts.h err.h idn.h csm.h \
envmod.h List.h deftbl.h db.h Syntax.h AttrDefs.h GlobDef.h \
IntfAttrib.h LigaDid.h SymComp.h SymInh.h Names.h GramCon.h global.h \
deftbl.h LIGA.h LIGAMacros.h global.h 
ptg_gen.o:      ptg_gen.c ptg_gen.h 
OutStr.o:       OutStr.c OutStr.h 
SymInh.o:       SymInh.c Lido.head LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h global.h deftbl.h 
IntfAttrib.o:   IntfAttrib.c Lido.head LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h global.h deftbl.h 
SymComp.o:      SymComp.c Lido.head LIGA.h LIGAMacros.h liga_func.h \
liga_To_func.h ligaconsts.h err.h idn.h csm.h envmod.h List.h deftbl.h \
db.h Syntax.h AttrDefs.h GlobDef.h IntfAttrib.h LigaDid.h SymComp.h \
SymInh.h Names.h GramCon.h global.h deftbl.h 
obstack.o:      obstack.c obstack.h 
treestack.o:    treestack.c err.h treecon.h treestack.h treestack.h 
glahead.o:      glahead.c err.h source.h xtables.h xcode.h 
p_mkstr.o:      p_mkstr.c p_mkstr.h 
str.o:  str.c str.h csm.h 
pascalCom.o:    pascalCom.c err.h gla.h source.h 
auxScanEOL.o:   auxScanEOL.c err.h gla.h source.h 
CchStr.o:       CchStr.c err.h source.h gla.h 
int.o:  int.c int.h 
Ccomment.o:     Ccomment.c err.h gla.h source.h 
pascalStr.o:    pascalStr.c err.h gla.h 
attrmain.o:     attrmain.c treecon.h visitprocs.h treestack.h 
dfltclp.o:      dfltclp.c source.h 
